      SUBROUTINE BKCEMN(NF,NE,NS,S,OPT,IND,SIND,INDE,COVSEL,LDCVSL,
     .     LONSEL,LATSEL,IFAULT,INDMEAN,VERB,XSW,YSW,XNE,YNE,ANGLE,
     .     NX,NY,DX,DY,XG,YG,ZG,LDZG,VARG,LDVARG,DOG,LDDOG,LON,LAT,Z,
     .     EXTRAP,N,COVTYPE,COVPAR,COVMAT,LDCOV,C0VEC,COV0,
     .     EXTCOV,TREND,NTREND,MUPR,LDMPR,
     .     PHIPR,LDPHPR,LONPR,LATPR,NPR,TYPPR,
     .     RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,MU,LAMBDA,LAMBD0,
     .     IERR,GLSMTH)

*
*  -- user defined driver routine --   
*     
*
      IMPLICIT NONE
*     .. Scalar Arguments ..
      INTEGER NF, NE, NS, NX, NY, VERB, LDCVSL, IFAULT,
     .     LDCOV, LDMPR, LDPHPR, LDZG, LDVARG, LDDOG,
     .     IERR, EXTRAP, COVTYPE, EXTCOV, TREND, NTREND, NSEARCH,
     .     NSMIN, NSMAX, NPR, MODE, GLSMTH, LWORK, N
      DOUBLE PRECISION OPT, LAMBD0, COV0, XSW, YSW, XNE, YNE, ANGLE, 
     .     DX, DY, RSEARCH
*     .. Array Arguments ..
      INTEGER S(*), IND(*),SIND(*),INDE(*), DOG(LDDOG,*), TYPPR(*),
     .     INDMEAN(*)
      DOUBLE PRECISION COVSEL(LDCVSL,*), LONSEL(*), LATSEL(*),
     .     XG(*), YG(*), ZG(LDZG,*), VARG(LDVARG,*), LON(*), LAT(*),
     .     Z(*), COVMAT(LDCOV,*),C0VEC(*), MU(*), LAMBDA(*),
     .     COVPAR(*), MUPR(LDMPR,*), PHIPR(LDPHPR,*), LONPR(*), LATPR(*)


c     local variables
      INTEGER            I, J, K, CARDS, NA, COUNT, 
     .                   NMR, IP1, NI, SEARCHNB(1), RETLM
      DOUBLE PRECISION   KMEAN, KMIN
*     ..
*     .. Local Arrays ..
*     ..
*     .. External Functions ..
*     ..
*     .. External Subroutines ..
      EXTERNAL           BKMN, BK_GRID, PSUBM 
*     ..
*     .. Intrinsic Functions ..
*     ..
*     .. Executable Statements ..
*
*

      KMEAN=0.0D0
      RETLM=0
      NA=N
      NI=NF+NS
      DO 10 I=1,NE
         S(I)=0
 10   CONTINUE

      DO 11 I=1,NF
         IND(I)=I
         INDMEAN(I)=I
         LONSEL(I)=LON(I)
         LATSEL(I)=LAT(I)
 11   CONTINUE
      
      DO 12 I=NF+1,NA
         IND(I)=0
         INDMEAN(I)=0
         LONSEL(I)=0
         LATSEL(I)=0
 12   CONTINUE

      IF (NS .LT. 1 .OR. NS .GT. NE) RETURN
      IFAULT = 0
      COUNT = 0
      NMR = NE - NS


*  Initialize J(1) to lower limit separately, since lower limit for
*  each index depends on lower limit for previous index

      I = 1
      SIND(1) = 1

*  Initialize indices for loops i=1,...,r to lower limits

 13   CONTINUE 

      IF (I .EQ. NS) GOTO 15

      IP1 = I + 1

      DO 14 K = IP1, NS
         SIND(K) = SIND(K-1) + 1
 14   CONTINUE

      

*  Update the count (count) of combinations and process the current
*  combination.  The call to Subroutine job may be replaced by
*  statements to process the current combination.

 15   CONTINUE
      COUNT = COUNT + 1

* Exhaustive search
* Computation of the krige variance of the resulting network 

c      call job(NS, NE, SIND, count)
      CALL BKMN(NF,NE,NS,S,OPT,IND,SIND,INDE,COVSEL,LDCVSL,
     .     LONSEL,LATSEL,KMEAN,VERB,XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .     DX,DY,XG,YG,ZG,LDZG,VARG,LDVARG,DOG,LDDOG,LON,LAT,Z,
     .     EXTRAP,N,NA,COVTYPE,COVPAR,COVMAT,LDCOV,C0VEC,COV0,
     .     EXTCOV,TREND,NTREND,MUPR,LDMPR,
     .     PHIPR,LDPHPR,LONPR,LATPR,NPR,TYPPR,
     .     RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,MU,LAMBDA,LAMBD0,
     .     IERR,GLSMTH)
      if (verb.eq.1) write (*,*) 'no of comb. / mean variance:', count, 
     .    '/', kmean

*     Determining the minimum of the maximal krige variance for the 
*     actual selection and storing the index set for which the maximal 
*     krige variance attained its minimum

      IF (COUNT .EQ. 1) THEN
         KMIN=KMEAN
         DO 16 K=1,NS
            INDMEAN(K+NF)=SIND(K)+NF
 16      CONTINUE
      ELSE
         IF (KMEAN .LT. KMIN) THEN
            KMIN=KMEAN
            DO 17 K=1,NS
               INDMEAN(NF+K)=SIND(K)+NF
 17         CONTINUE
            if (verb.eq.1) write (*,*) 'new min:', kmin
         ENDIF
      ENDIF
      
      I = NS
 18   CONTINUE
      
      IF (SIND(I) .LT. NMR+I) GOTO 19
      I = I-1
      
*  Return after all indices have achieved their upper limits

      IF (I .LE. 0) THEN
         
* Calculating krige prediction and krige variance for the greedy solution

         DO 20 K=1,NS
            LONSEL(NF+K)=LON(INDMEAN(NF+K))
            LATSEL(NF+K)=LAT(INDMEAN(NF+K))
c     ZSEL? not available!
            SIND(K)=INDMEAN(NF+K)
 20      CONTINUE
         CALL PSUBM(COVMAT,NA,NA,COVSEL,NA,INDMEAN,NI)
      CALL BK_GRID(XSW, YSW, XNE, YNE, ANGLE, NX, NY, DX, DY, XG, 
     .     YG, ZG, VARG, DOG, LONSEL, LATSEL, Z, EXTRAP, NI, 
     .     COVTYPE, COVPAR, COVSEL, LDCVSL, EXTCOV, TREND, NTREND,
     .     MUPR, LDMPR, PHIPR, LDPHPR, LONPR, LATPR, NPR, TYPPR,
     .     RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,
     .     MU, LAMBDA, LAMBD0, SEARCHNB, IERR, RETLM, GLSMTH)
               
         OPT=KMIN
         RETURN
      ENDIF
      GOTO 18
 19   CONTINUE
      SIND(I) = SIND(I) + 1
      GOTO 13

      RETURN      
      END 
      

c      subroutine job (n, r, j, kount)
c      integer n, r, j(r),i,kount
c 55   format ('Kombination: ', I3)
c      write (*,55) kount  
c      return
c      end
