      SUBROUTINE BKGRMX(NF,NE,NS,S,OPT,IND,COVSEL,LDCVSL,
     .     LONSEL,LATSEL,VERB,XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .     DX,DY,XG,YG,ZG,LDZG,VARG,LDVARG,DOG,LDDOG,LON,LAT,Z,
     .     EXTRAP,N,COVTYPE,COVPAR,COVMAT,LDCOV,C0VEC,COV0,
     .     EXTCOV,TREND,NTREND,MUPR,LDMPR,
     .     PHIPR,LDPHPR,LONPR,LATPR,NPR,TYPPR,
     .     RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,MU,LAMBDA,LAMBD0,
     .     IERR,GLSMTH)

*
*  -- user defined driver routine --   
*     
*
      IMPLICIT NONE
*     .. Scalar Arguments ..
      INTEGER NF, NE, NS, NX, NY, VERB, LDCVSL,
     .     LDCOV, LDMPR, LDPHPR, LDZG, LDVARG, LDDOG,
     .     IERR, EXTRAP, COVTYPE, EXTCOV, TREND, NTREND, NSEARCH,
     .     NSMIN, NSMAX, NPR, MODE, GLSMTH, LWORK, N
      DOUBLE PRECISION OPT, LAMBD0, COV0, XSW, YSW, XNE, YNE, ANGLE, 
     .     DX, DY, RSEARCH
*     .. Array Arguments ..
      INTEGER S(*), IND(*), DOG(LDDOG,*), TYPPR(*)
      DOUBLE PRECISION COVSEL(LDCVSL,*), LONSEL(*), LATSEL(*),
     .     XG(*), YG(*), ZG(LDZG,*), VARG(LDVARG,*), LON(*), LAT(*),
     .     Z(*), COVMAT(LDCOV,*),C0VEC(*), MU(*), LAMBDA(*),
     .     COVPAR(*), MUPR(LDMPR,*), PHIPR(LDPHPR,*), LONPR(*), LATPR(*)



c     local variables
      INTEGER I, J, K, CARDS, IMIN, NA, COUNT, 
     .     NI, SEARCHNB(1), RETLM
      DOUBLE PRECISION KMAX1, KMAX, KMIN
*     ..
*     .. Local Arrays ..
*     ..
*     .. External Functions ..
*     ..
*     .. External Subroutines ..
      EXTERNAL BK_GRID, PSUBM, PIND
*     ..
*     .. Intrinsic Functions ..
*     ..
*     .. Executable Statements ..
*
* Initializing
 
      NA=N
      RETLM=0
      DO 10 I=1,NE
         S(I)=0
 10   CONTINUE
      
      DO 11 I=1,NF
         IND(I)=I
         LONSEL(I)=LON(I)
         LATSEL(I)=LAT(I)

 11   CONTINUE
      
      DO 12 I=NF+1,NA
         IND(I)=0
         LONSEL(I)=0
         LATSEL(I)=0
 12   CONTINUE
      IMIN=1


* Main loop

 20   CONTINUE

* Computation of the actual index set IND and its cardinality
 
      K=NF+1
      CARDS=NF
      DO 21 I=1,NE
         IF (S(I).NE.0) THEN
            CARDS=CARDS+1
            IND(K)=S(I)
            K=K+1
         ENDIF
 21   CONTINUE

* Is the actual solution S feasible?

      IF (CARDS.LT.(NF+NS)) THEN 
         GOTO 22
      ELSE
         GOTO 30
      ENDIF
 22   CONTINUE

      

* Selecting a station as candidate for augmenting the network
* Computation of the krige variance of the resulting network 

      COUNT=1
      DO 23 I=1,NE
         IF (S(I) .EQ. 0) THEN 
            S(I)=NF+I
            CALL PIND(S,IND,NA,NE,NF,NI)
            DO 230 J=NF+1,NI
               LONSEL(J)=LON(IND(J))
               LATSEL(J)=LAT(IND(J))

 230        CONTINUE
            CALL PSUBM(COVMAT,NA,NA,COVSEL,NA,IND,NI)

          CALL BK_GRID(XSW, YSW, XNE, YNE, ANGLE, NX, NY, DX, DY, XG, 
     .           YG, ZG, VARG, DOG, LONSEL, LATSEL, Z, EXTRAP, NI, 
     .           COVTYPE, COVPAR, COVSEL, LDCVSL, EXTCOV, TREND, NTREND,
     .           MUPR, LDMPR, PHIPR, LDPHPR, LONPR, LATPR, NPR, TYPPR,
     .           RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,
     .           MU, LAMBDA, LAMBD0, SEARCHNB, IERR, RETLM, GLSMTH)
            
*     Determining the maximum krige variance for the actual selection 

          KMAX=0.0D0
          DO 24 J=1,NX
             DO 25 K=1,NY
                IF(DOG(J,K).EQ.1) THEN
                   KMAX1=VARG(J,K)
                   IF (KMAX1 .GE. KMAX) THEN
                      KMAX=KMAX1
                   ENDIF
                ENDIF
 25          CONTINUE
 24       CONTINUE
      if (verb.eq.1) write (*,*) 'no of comb. / card of selection. / mea
     .n variance:', count, '/', cards, '/', kmax
  
*     Determining the minimum of the maximal krige variance for the 
*     actual selection and storing the index for which the maximal 
*     krige variance attained its minimum

            IF (COUNT .EQ. 1) THEN
               KMIN=KMAX
               IMIN=I
            ELSE
               IF (KMAX .LE. KMIN) THEN
                  KMIN=KMAX
                  IMIN=I
               ENDIF
            ENDIF
            S(I)=0
            CALL PIND(S,IND,NA,NE,NF,NI)
            COUNT=COUNT+1
         ENDIF 
 23   CONTINUE

* Augmenting the network selecting the station IMIN

      S(IMIN)=NF+IMIN
      GOTO 20

* Greedy solution found

 30   CONTINUE

* Calculating krige prediction and krige variance for the greedy solution

      CALL PIND(S,IND,NA,NE,NF,NI)
      DO 40 I=NF+1,NI
         LONSEL(I)=LON(IND(I))
         LATSEL(I)=LAT(IND(I))


 40   CONTINUE
      CALL PSUBM(COVMAT,NA,NA,COVSEL,NA,IND,NI)
      CALL BK_GRID(XSW, YSW, XNE, YNE, ANGLE, NX, NY, DX, DY, XG, 
     .     YG, ZG, VARG, DOG, LONSEL, LATSEL, Z, EXTRAP, NI, 
     .     COVTYPE, COVPAR, COVSEL, LDCVSL, EXTCOV, TREND, NTREND,
     .     MUPR, LDMPR, PHIPR, LDPHPR, LONPR, LATPR, NPR, TYPPR,
     .     RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,
     .     MU, LAMBDA, LAMBD0, SEARCHNB, IERR, RETLM, GLSMTH)
      OPT=KMIN
      RETURN
      END 
      
