      SUBROUTINE KCEMX(NF,NE,NS,S,OPT,IND,SIND,INDE,
     .                  XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .                  DX,DY,XG,YG,ZG,VARG,DOG,
     .                  LON,LAT,Z,EXTRAP,N,
     .                  COVTYPE,COVPAR,COV,C0,COV0,EXTCOV,TREND,
     .                  NTREND,RSEARCH,NSEARCH,NSMIN,NSMAX,FWORK,F0WORK,
     .                  DIST,INDSNB,INDSNA,INDSRT,KWORK,NKWORK,RHSWORK,
     .                  IPIV,MODE,MU,LAMBDA,BITS,
     .                  IERR,LCOV,LLON,LLAT,IFAULT,INDMAX,VERB)

      IMPLICIT NONE
*
*  -- user defined driver routine --   
*     
*
*     .. Scalar Arguments ..
      INTEGER NF, NE, NS, NX, NY, N,
     .        COVTYPE, EXTCOV, TREND, NTREND, MODE, IFAULT, NKWORK,
     .        NSEARCH, NSMIN, NSMAX, IERR, IPT, EXTRAP, VERB
      DOUBLE PRECISION OPT, XSW, YSW, XNE, YNE, ANGLE, DX, DY, RSEARCH
*     .. Array Arguments ..
      INTEGER S(*), IND(*), SIND(*), INDE(*), INDMAX(*), BITS(*),
     .        INDSNB(*), INDSNA(*), INDSRT(*), IPIV(*), DOG(NX,*)
     .        
      DOUBLE PRECISION XG(*),YG(*),ZG(NX,*),VARG(NX,*),
     .                 LON(*), LAT(*), Z(*), COV(N,*), C0(*), COV0(*),
     .                 FWORK(N,*), F0WORK(NTREND,*), DIST(*),
     .                 KWORK(NKWORK,*), RHSWORK(*), MU(*), LAMBDA(*),
     .                 COVPAR(*), LCOV(N,*), LLON(*), LLAT(*)


c     local variables
      INTEGER            I, J, K, CARDS, NA, COUNT, LDCOV, 
     .                   NMR, IP1, NI, RETLM
      DOUBLE PRECISION   KMAX1, KMAX, KMIN
*     ..
*     .. Local Arrays ..
*     ..
*     .. External Functions ..
*     ..
*     .. External Subroutines ..
      EXTERNAL           KSRMX, KRIGE_GRID, PSUBM 
*     ..
*     .. Intrinsic Functions ..
*     ..
*     .. Executable Statements ..
*
*
* Initializing
 
      RETLM=0

      KMAX=0.0D0
      LDCOV=N
      NA=N
      NI=NF+NS
      DO 10 I=1,NE
         S(I)=0
 10   CONTINUE

      DO 11 I=1,NF
         IND(I)=I
         INDMAX(I)=I
         LLON(I)=LON(I)
         LLAT(I)=LAT(I)
 11   CONTINUE
      
      DO 12 I=NF+1,NA
         IND(I)=0
         INDMAX(I)=0
         LLON(I)=0
         LLAT(I)=0
 12   CONTINUE

      IF (NS .LT. 1 .OR. NS .GT. NE) RETURN
      IFAULT = 0
      COUNT = 0
      NMR = NE - NS


*  Initialize J(1) to lower limit separately, since lower limit for
*  each index depends on lower limit for previous index

      I = 1
      SIND(1) = 1

*  Initialize indices for loops i=1,...,r to lower limits

 13   CONTINUE 

      IF (I .EQ. NS) GOTO 15

      IP1 = I + 1

      DO 14 K = IP1, NS
         SIND(K) = SIND(K-1) + 1
 14   CONTINUE

      

*  Update the count (count) of combinations and process the current
*  combination.  The call to Subroutine job may be replaced by
*  statements to process the current combination.

 15   CONTINUE
      COUNT = COUNT + 1

* Exhaustive search
* Computation of the krige variance of the resulting network 

c      call job(NS, NE, SIND, count)
      CALL KSRMX(NF,NE,NS,S,OPT,IND,SIND,INDE,
     .                    XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .                    DX,DY,XG,YG,ZG,VARG,DOG,
     .                    LON,LAT,Z,EXTRAP,NI,NA,
     .                    COVTYPE,COVPAR,COV,LDCOV,C0,COV0,EXTCOV,TREND,
     .                    NTREND,RSEARCH,NSEARCH,NSMIN,NSMAX,FWORK,
     .                    F0WORK,DIST,INDSNB,INDSNA,INDSRT,KWORK,NKWORK,
     .                    RHSWORK,IPIV,MODE,MU,LAMBDA,BITS,
     .                    IERR,LCOV,LLON,LLAT,KMAX)
      if (verb.eq.1) write (*,*) 'no of comb. / max variance:', count, 
     .    '/', kmax

*     Determining the minimum of the maximal krige variance for the 
*     actual selection and storing the index set for which the maximal 
*     krige variance attained its minimum

      IF (COUNT .EQ. 1) THEN
         KMIN=KMAX
         DO 16 K=1,NS
            INDMAX(K+NF)=SIND(K)+NF
 16      CONTINUE
      ELSE
         IF (KMAX .LT. KMIN) THEN
            KMIN=KMAX
            DO 17 K=1,NS
               INDMAX(NF+K)=SIND(K)+NF
 17         CONTINUE
            if (verb.eq.1) write (*,*) 'new min:', kmin
         ENDIF
      ENDIF
      
      I = NS
 18   CONTINUE
      
      IF (SIND(I) .LT. NMR+I) GOTO 19
      I = I-1
      
*  Return after all indices have achieved their upper limits

      IF (I .LE. 0) THEN
         
* Calculating krige prediction and krige variance for the greedy solution

         DO 20 K=1,NS
            LLON(NF+K)=LON(INDMAX(NF+K))
            LLAT(NF+K)=LAT(INDMAX(NF+K))
            SIND(K)=INDMAX(NF+K)
 20      CONTINUE
         CALL PSUBM(COV,NA,NA,LCOV,NA,INDMAX,NI)
      CALL KRIGE_GRID(XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .     DX,DY,XG,YG,ZG,VARG,DOG,
     .     LLON,LLAT,Z,EXTRAP,NI,
     .     COVTYPE,COVPAR,LCOV,LDCOV,EXTCOV,TREND,
     .     NTREND,RSEARCH,NSEARCH,NSMIN,NSMAX,MODE,MU,LAMBDA,BITS,
     .     RETLM,IERR)
            
         OPT=KMIN
         RETURN
      ENDIF
      GOTO 18
 19   CONTINUE
      SIND(I) = SIND(I) + 1
      GOTO 13

      RETURN      
      END 
      

c      subroutine job (n, r, j, kount)
c      integer n, r, j(r),i,kount
c 55   format ('Kombination: ', I3)
c      write (*,55) kount  
c      return
c      end
